<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ACL/include/ACL/Transport/HTTP2StreamPool.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.9.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_b1dfedc9efa610ba8c818c30206ff41f.html">ACL</a></li><li class="navelem"><a class="el" href="dir_1088b026815130b3cc8e9ac3f4525272.html">include</a></li><li class="navelem"><a class="el" href="dir_ce0d3eda4bb43bdcf8c1c51ff13ee585.html">ACL</a></li><li class="navelem"><a class="el" href="dir_711bc606e725cfd07f3f2b0a5f6ebc00.html">Transport</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">HTTP2StreamPool.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_h_t_t_p2_stream_pool_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_ACL_INCLUDE_ACL_TRANSPORT_HTTP2STREAMPOOL_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_ACL_INCLUDE_ACL_TRANSPORT_HTTP2STREAMPOOL_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_attachment_manager_8h.html">AVSCommon/AVS/Attachment/AttachmentManager.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_message_request_8h.html">AVSCommon/AVS/MessageRequest.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_h_t_t_p2_stream_8h.html">ACL/Transport/HTTP2Stream.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_message_consumer_interface_8h.html">ACL/Transport/MessageConsumerInterface.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span>acl {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html">HTTP2StreamPool</a> {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a5897e5d9b74197a96f448d17a9972c49">HTTP2StreamPool</a>(</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> maxStreams,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManager&gt; attachmentManager);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    std::shared_ptr&lt;HTTP2Stream&gt; <a class="code" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a6bdce447496019c123d6c3576f8590db">createGetStream</a>(</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">const</span> std::string&amp; url,</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">const</span> std::string&amp; authToken,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        std::shared_ptr&lt;MessageConsumerInterface&gt; messageConsumer);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    std::shared_ptr&lt;HTTP2Stream&gt; <a class="code" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a77578b6b88d1af82407571ad525cfddd">createPostStream</a>(</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">const</span> std::string&amp; url,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keyword">const</span> std::string&amp; authToken,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::shared_ptr&lt;avsCommon::avs::MessageRequest&gt; request,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        std::shared_ptr&lt;MessageConsumerInterface&gt; messageConsumer);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#afcd2752bb5fcb4ac934bbc9747558f7e">releaseStream</a>(std::shared_ptr&lt;HTTP2Stream&gt; stream);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    std::shared_ptr&lt;HTTP2Stream&gt; getStream(std::shared_ptr&lt;MessageConsumerInterface&gt; messageConsumer);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    std::vector&lt;std::shared_ptr&lt;HTTP2Stream&gt;&gt; m_pool;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordtype">int</span> m_numAcquiredStreams;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> m_maxStreams;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManager&gt; m_attachmentManager;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_nextStreamId;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;};</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;}  <span class="comment">// namespace acl</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_ACL_INCLUDE_ACL_TRANSPORT_HTTP2STREAMPOOL_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html">alexaClientSDK::acl::HTTP2StreamPool</a></div><div class="ttdef"><b>Definition:</b> HTTP2StreamPool.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool_html_a5897e5d9b74197a96f448d17a9972c49"><div class="ttname"><a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a5897e5d9b74197a96f448d17a9972c49">alexaClientSDK::acl::HTTP2StreamPool::HTTP2StreamPool</a></div><div class="ttdeci">HTTP2StreamPool(const int maxStreams, std::shared_ptr&lt; avsCommon::avs::attachment::AttachmentManager &gt; attachmentManager)</div><div class="ttdef"><b>Definition:</b> HTTP2StreamPool.cpp:36</div></div>
<div class="ttc" id="_message_consumer_interface_8h_html"><div class="ttname"><a href="_message_consumer_interface_8h.html">MessageConsumerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool_html_afcd2752bb5fcb4ac934bbc9747558f7e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#afcd2752bb5fcb4ac934bbc9747558f7e">alexaClientSDK::acl::HTTP2StreamPool::releaseStream</a></div><div class="ttdeci">void releaseStream(std::shared_ptr&lt; HTTP2Stream &gt; stream)</div><div class="ttdef"><b>Definition:</b> HTTP2StreamPool.cpp:114</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool_html_a77578b6b88d1af82407571ad525cfddd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a77578b6b88d1af82407571ad525cfddd">alexaClientSDK::acl::HTTP2StreamPool::createPostStream</a></div><div class="ttdeci">std::shared_ptr&lt; HTTP2Stream &gt; createPostStream(const std::string &amp;url, const std::string &amp;authToken, std::shared_ptr&lt; avsCommon::avs::MessageRequest &gt; request, std::shared_ptr&lt; MessageConsumerInterface &gt; messageConsumer)</div><div class="ttdef"><b>Definition:</b> HTTP2StreamPool.cpp:61</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:36</div></div>
<div class="ttc" id="_h_t_t_p2_stream_8h_html"><div class="ttname"><a href="_h_t_t_p2_stream_8h.html">HTTP2Stream.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool_html_a6bdce447496019c123d6c3576f8590db"><div class="ttname"><a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream_pool.html#a6bdce447496019c123d6c3576f8590db">alexaClientSDK::acl::HTTP2StreamPool::createGetStream</a></div><div class="ttdeci">std::shared_ptr&lt; HTTP2Stream &gt; createGetStream(const std::string &amp;url, const std::string &amp;authToken, std::shared_ptr&lt; MessageConsumerInterface &gt; messageConsumer)</div><div class="ttdef"><b>Definition:</b> HTTP2StreamPool.cpp:44</div></div>
<div class="ttc" id="_message_request_8h_html"><div class="ttname"><a href="_message_request_8h.html">MessageRequest.h</a></div></div>
<div class="ttc" id="_attachment_manager_8h_html"><div class="ttname"><a href="_attachment_manager_8h.html">AttachmentManager.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.9.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
